
# Projections - energy consumption
energy_by_mineral_projection_df <- total_production_projections_df %>% 
  dplyr::left_join(
    energy_intensities_dynamic,
    by = c("Mineral", "Year")
  ) %>% 
  dplyr::mutate(
    Energy_TJ_final = Production * 1e6 * `Energy_GJ/ton` / 1e3
  ) %>% 
  glimpse()


# Only Helium. That's all good.
# anti_joined <- total_production_projections_df %>% 
#   dplyr::anti_join(
#     energy_intensities_dynamic,
#     by = c("Mineral", "Year")
#   ) %>% 
#   print()


# Now it's about making graphs etc.
energy_total_projection_df <- energy_by_mineral_projection_df %>% 
  dplyr::group_by(Scenario, RR.scenario, Year, Range, Method) %>% # Taking out Scope
  dplyr::summarise(
    Energy_TJ_final = sum(Energy_TJ_final)
  ) %>% 
  print()



# Comparing with energy consumption targets, for each scenario:
tidy_tfc_sr_df <- tidy_sr_data %>% 
  # Note: we have excluded non-energy uses in the sorting_sr_1_5_data.R script!
  dplyr::filter(Variable == "Final Energy") %>% 
  dplyr::mutate(
    Final_Energy_TFC_TJ = Values_interpolated * 1e6,
    Year = as.numeric(Year)
  ) %>% 
  dplyr::ungroup() %>% 
  dplyr::select(-Variable, -Unit, -Values, -Values_interpolated, -ratio_non_energy_to_tfc) %>% 
  dplyr::rename(Scenario = Model_Scenario) %>% 
  print()


tidy_tfc_df <- tidy_tfc_sr_df %>% 
  dplyr::bind_rows(degrowth_final_energy_df) %>% 
  print()


mining_energy_to_tfc_projection_df <- energy_total_projection_df %>% 
  dplyr::left_join(
    tidy_tfc_df,
    by = c("Scenario", "Year")
  ) %>% 
  dplyr::mutate(
    Ratio_Mining_to_TFC = Energy_TJ_final / Final_Energy_TFC_TJ
  ) %>% 
  print()

