# Scenarios to keep
# We exclude LED for now because it has a different data structure and requires different treatment.
# selected_scenarios <- c("AIM/CGE 2.0_SSP1-19", "MESSAGE-GLOBIOM 1.0_SSP2-19", "REMIND-MAgPIE 1.5_SSP5-19",
#                         "IEA Energy Technology Perspective Model 2017_B2DS", "MESSAGEix-GLOBIOM 1.0_LowEnergyDemand")
# 
# 
# # Variables to keep
# relevant_variables <- c("Capacity|Electricity|Solar",
#                         "Capacity|Electricity|Solar|PV",
#                         "Capacity|Electricity|Solar|CSP",
#                         "Capacity|Electricity|Wind",
#                         "Capacity|Electricity|Wind|Onshore",
#                         "Capacity|Electricity|Wind|Offshore",
#                         "Cumulative Capacity|Electricity|Solar",
#                         "Cumulative Capacity|Electricity|Solar|CSP",
#                         "Cumulative Capacity|Electricity|Solar|PV",
#                         "Cumulative Capacity|Electricity|Wind",
#                         "Cumulative Capacity|Electricity|Wind|Onshore",
#                         "Cumulative Capacity|Electricity|Wind|Offshore",
#                         "Final Energy",
#                         "Final Energy|Industry",
#                         "Final Energy|Non-Energy Use",
#                         "Final Energy|Residential and Commercial",
#                         "Final Energy|Transportation",
#                         "GDP|MER",
#                         "GDP|PPP",
#                         "Primary Energy")
# 
# 
# # Reading, and selecting scenarios and data
# sr_1.5_data <- read_csv("iamc15_scenario_data_world_r2.0.csv",
#                         col_names = TRUE,
#                         col_types = cols(
#                           .default = col_double(),
#                           Model = col_character(),
#                           Scenario = col_character(),
#                           Region = col_character(),
#                           Variable = col_character(),
#                           Unit = col_character()
#                         )) %>%
#   mutate(
#     Model_Scenario = str_c(Model, Scenario, sep = "_")
#   ) %>%
#   relocate(Model_Scenario, .after = Scenario) %>%
#   filter(Model_Scenario %in% selected_scenarios, Variable %in% relevant_variables) %>%
#   print()
# 
# 
# # Interpolating data, and pushing to tidy format
# tidy_sr_data <- sr_1.5_data %>%
#   select(-Scenario, -Region, -Model) %>%
#   pivot_longer(cols = -c("Model_Scenario", "Variable", "Unit"), names_to = "Year", values_to = "Values") %>%
#   filter(Year >= 2010) %>%
#   group_by(Model_Scenario, Variable, Unit) %>%
#   arrange(Model_Scenario, Variable, Unit, Year) %>%
#   # Here we modify Final Energy (INCLUDING non-energy uses) so that it is equal in 2010 and 2015 to its real value.
#   # We take care of non energy-uses later on.
#   dplyr::mutate(
#     Values = dplyr::case_when(
#       (Variable == "Final Energy" & Year == 2010) ~ 8833682 * 41.868 / 1e6,
#       (Variable == "Final Energy" & Year == 2015) ~ 9414132 * 41.868 / 1e6,
#       TRUE ~ Values
#     )
#   ) %>%
#   mutate(
#     Values_interpolated = zoo::na.approx(Values, maxgap = 10, rule = 2),
#     Model_Scenario = case_when(
#       Model_Scenario == "AIM/CGE 2.0_SSP1-19" ~ "SSP1_1.9",
#       Model_Scenario == "IEA Energy Technology Perspective Model 2017_B2DS" ~ "B2DS",
#       Model_Scenario == "MESSAGE-GLOBIOM 1.0_SSP2-19" ~ "SSP2_1.9",
#       Model_Scenario == "REMIND-MAgPIE 1.5_SSP5-19" ~ "SSP5_1.9",
#       TRUE ~ Model_Scenario
#     )
#   ) %>%
#   print()
# 
# 
# # Now, figuring out the ratios PV/Solar and Onshore/Wind in the B2DS scenario.
# # This will be used to extrapolate all other scenarios.
# b2ds_res_ratios <- tidy_sr_data %>%
#   filter(Model_Scenario == "B2DS",
#          Variable %in% c(
#            "Cumulative Capacity|Electricity|Solar",
#            "Cumulative Capacity|Electricity|Solar|CSP",
#            "Cumulative Capacity|Electricity|Solar|PV",
#            "Cumulative Capacity|Electricity|Wind",
#            "Cumulative Capacity|Electricity|Wind|Onshore",
#            "Cumulative Capacity|Electricity|Wind|Offshore"
#          ),
#          Year <= 2060) %>%
#   select(-Values) %>%
#   pivot_wider(names_from = Variable, values_from = Values_interpolated) %>%
#   mutate(
#     ratio_pv_to_solar = `Cumulative Capacity|Electricity|Solar|PV` / `Cumulative Capacity|Electricity|Solar`,
#     ratio_onshore_to_wind = `Cumulative Capacity|Electricity|Wind|Onshore` / `Cumulative Capacity|Electricity|Wind`
#   ) %>%
#   ungroup() %>%
#   select(Year, ratio_pv_to_solar, ratio_onshore_to_wind) %>%
#   print()
# 
# 
# # Finding the ratio of non-energy uses to TFC in the B2DS scenario.
# # The same ratio will be applied to all other scenarios.
# b2ds_non_energy_to_tfc <- tidy_sr_data %>%
#   filter(Model_Scenario == "B2DS",
#          Variable %in% c("Final Energy", "Final Energy|Non-Energy Use")) %>%
#   select(-Values) %>%
#   pivot_wider(names_from = Variable, values_from = Values_interpolated) %>%
#   mutate(
#     ratio_non_energy_to_tfc = `Final Energy|Non-Energy Use` / `Final Energy`
#   ) %>%
#   select(-`Final Energy|Non-Energy Use`, -`Final Energy`) %>%
#   # Here also we add historical data in the period 2010-2015
#   dplyr::mutate(
#     ratio_non_energy_to_tfc = dplyr::case_when(
#       Year == 2010 ~ 0.08627829,
#       Year == 2011 ~ 0.08520363,
#       Year == 2012 ~ 0.08737028,
#       Year == 2013 ~ 0.08571165,
#       Year == 2014 ~ 0.08826574,
#       Year == 2015 ~ 0.08793337,
#       TRUE ~ ratio_non_energy_to_tfc
#     )
#   ) %>%
#   print()
# 
# 
# # Excluding non-energy uses from all scenarios by using the same ratio as B2DS:
# tidy_sr_data <- tidy_sr_data %>%
#   left_join(b2ds_non_energy_to_tfc, by = "Year", suffix = c("", ".y")) %>%
#   mutate(
#     Values_interpolated = case_when(
#       Variable == "Final Energy" ~ (Values_interpolated * (1 - ratio_non_energy_to_tfc)),
#       TRUE ~ Values_interpolated
#     )
#   ) %>%
#   select(-Model_Scenario.y, -Unit.y) %>%
#   print()
# 
# 
# # Getting time series of final-to-primary ratios:
# b2ds_final_to_primary_df <- tidy_sr_data %>%
#   dplyr::filter(Model_Scenario == "B2DS") %>%
#   # Non-energy use has already been taken out of TFC.
#   dplyr::filter(Variable == "Final Energy" | Variable == "Primary Energy") %>%
#   dplyr::filter(Year < 2061) %>%
#   dplyr::select(-Values, -ratio_non_energy_to_tfc) %>%
#   tidyr::pivot_wider(names_from = Variable, values_from = Values_interpolated) %>%
#   dplyr::mutate(
#     final_to_primary = `Final Energy` / `Primary Energy`
#   ) %>%
#   dplyr::ungroup() %>%
#   dplyr::select(-Unit, -Model_Scenario, -`Final Energy`, -`Primary Energy`) %>%
#   dplyr::mutate(
#     Year = as.numeric(Year)
#   ) %>%
#   print()

# save(sr_1.5_data, tidy_sr_data, b2ds_final_to_primary_df, file = "sr_1_5_data.RData")

load("sr_1_5_data.RData")

